using NIDAQmxConst;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NIDAQmx.Internal
{
    internal class Read
    {/// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadRelativeTo(System.IntPtr taskHandle, ref ReadRelativeTo data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32->int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadRelativeTo(System.IntPtr taskHandle, ReadRelativeTo data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadRelativeTo(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOffset(System.IntPtr taskHandle, ref int data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32->int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadOffset(System.IntPtr taskHandle, int data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadOffset(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadChannelsToRead(System.IntPtr taskHandle, ref byte data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadChannelsToRead(System.IntPtr taskHandle, [System.Runtime.InteropServices.InAttribute()][System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadChannelsToRead(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadReadAllAvailSamp(System.IntPtr taskHandle, ref bool data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32->uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadReadAllAvailSamp(System.IntPtr taskHandle, bool data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadReadAllAvailSamp(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadAutoStart(System.IntPtr taskHandle, ref bool data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32->uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadAutoStart(System.IntPtr taskHandle, bool data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadAutoStart(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOverWrite(System.IntPtr taskHandle, ref ReadOverWrite data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32->int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadOverWrite(System.IntPtr taskHandle, ReadOverWrite data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadOverWrite(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingFilePath(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingFilePath(System.IntPtr taskHandle, [System.Runtime.InteropServices.InAttribute()][System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingFilePath(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingMode(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32->int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingMode(System.IntPtr taskHandle, LoggingMode data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingMode(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingTDMSGroupName(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingTDMSGroupName(System.IntPtr taskHandle, [System.Runtime.InteropServices.InAttribute()][System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingTDMSGroupName(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingTDMSOperation(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32->int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingTDMSOperation(System.IntPtr taskHandle, LoggingOperation data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingTDMSOperation(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingPause(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32->uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingPause(System.IntPtr taskHandle, bool data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingPause(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt64*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingSampsPerFile(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt64->unsigned __int64
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingSampsPerFile(System.IntPtr taskHandle, ulong data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingSampsPerFile(System.IntPtr taskHandle);
        
        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingFileWriteSize(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingFileWriteSize(System.IntPtr taskHandle, uint data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingFileWriteSize(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt64*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetLoggingFilePreallocationSize(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt64->unsigned __int64
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetLoggingFilePreallocationSize(System.IntPtr taskHandle, ulong data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetLoggingFilePreallocationSize(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt64*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadCurrReadPos(System.IntPtr taskHandle,IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadAvailSampPerChan(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt64*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadTotalSampPerChanAcquired(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadCommonModeRangeErrorChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadCommonModeRangeErrorChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadExcitFaultChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadExcitFaultChans(System.IntPtr taskHandle,IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOvercurrentChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOvercurrentChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOvertemperatureChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOvertemperatureChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOpenChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOpenChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOpenChansDetails(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOpenCurrentLoopChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOpenCurrentLoopChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOpenThrmcplChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOpenThrmcplChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOverloadedChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadOverloadedChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadInputLimitsFaultChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadInputLimitsFaultChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadPLLUnlockedChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadPLLUnlockedChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadPowerSupplyFaultChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadPowerSupplyFaultChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadSyncUnlockedChansExist(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadSyncUnlockedChans(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadAccessoryInsertionOrRemovalDetected(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: char*
        ///bufferSize: uInt32->unsigned int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadDevsWithInsertedOrRemovedAccessories(System.IntPtr taskHandle, IntPtr data, uint bufferSize);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: bool32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadChangeDetectHasOverflowed(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadRawDataWidth(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadNumChans(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: uInt32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadDigitalLinesBytesPerChan(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadWaitMode(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: int32->int
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadWaitMode(System.IntPtr taskHandle, WaitMode data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadWaitMode(System.IntPtr taskHandle);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: float64*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxGetReadSleepTime(System.IntPtr taskHandle, IntPtr data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        ///data: float64->double
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxSetReadSleepTime(System.IntPtr taskHandle, double data);


        /// Return Type: int32->int
        ///taskHandle: TaskHandle->void*
        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
        public delegate NIDAQmx.DAQmxEnum.Result DAQmxResetReadSleepTime(System.IntPtr taskHandle);

    }
}
